Oracle Coherence for C++ API
Release 3.6.0.0
E15728-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# RawTime Class Reference

`#include <coherence/io/pof/RawTime.hpp>`

Inherits Object.

List of all members.

## Detailed Description

Raw immutable POF time value.

Author:
  jh 2008.04.08

## Public Types
typedef spec::Handle | Handle
| RawTime Handle definition.
typedef spec::View | View
| RawTime View definition.
typedef spec::Holder | Holder
| RawTime Holder definition.
typedef struct tm | BoxedType
| The boxed native type.
## Public Member Functions
virtual bool | equals (Object::View v) const
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual bool | isImmutable () const
| Return `true` iff no further changes can be made to the Object, that would effect the outcome of a call to its equals method. Except for Objects which are naturally immutable (such as String), being immutable generally implies that the Object is only referenced via const pointers or views. Objects which hold references to child Objects, may need to take the immutability of their children into account when determining their own immutability. This extended check is not performed by the default implementation, but can be integrated into the immutability checks by overriding this method, as well as making use of MemberHandles to reference child Objects. A typical derived implementation may look as follows:
     bool isImmutable() const
         {
         if (m_fImmutable) // check recorded state
             {
             return true; // already marked as immutable, avoid calculation
             }
         else if (Object::isImmutable()) // ensure shallow immutability
             {
             // ensure deep immutability
             if (m_child1->isImmutable() && m_child2->isImmutable() ...
                                         && m_childN->isImmutable())
                 {
                 // record and return immutability
                 return m_fImmutable = true;
                 }
             // some Objects which comprise this Object are still mutable
             }
         return false;
         }
The default implementation return true iff the Object is only referenced via const pointers and or views. Returns: true iff the Object is immutable
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual int32_t | getHour () const
| Determine the time's hour value.
virtual int32_t | getMinute () const
| Determine the time's minute value.
virtual int32_t | getSecond () const
| Determine the time's second value.
virtual int32_t | getNano () const
| Determine the time's nanosecond value.
virtual bool | hasTimezone () const
| Determine if the time value has an explicit timezone.
virtual bool | isUTC () const
| Determine if the time value uses UTC.
virtual int32_t | getHourOffset () const
| Determine the timezone's hour offset value.
virtual int32_t | getMinuteOffset () const
| Determine the timezone's minute offset value.
virtual | operator struct tm () const
| Convert the RawTime to a POSIX datetime struct.
## Protected Member Functions
| RawTime (int32_t nHour, int32_t nMinute, int32_t nSecond, int32_t nNano, bool fUTC)
| Construct a raw POF time value.
| RawTime (int32_t nHour, int32_t nMinute, int32_t nSecond, int32_t nNano, int32_t nHourOffset, int32_t nMinuteOffset)
| Construct a raw POF time value with a timezone.
| RawTime (const struct tm &timeinfo, bool fUTC=false)
| Construct a raw POF time value from a POSIX datetime struct.
| RawTime (const RawTime &that)
| Copy constructor.
## Protected Attributes
int32_t | m_nHour
| The hour number.
int32_t | m_nMinute
| The minute number.
int32_t | m_nSecond
| The second number.
int32_t | m_nNano
| The nanosecond number.
int32_t | m_nTimeZoneType
| The timezone indicator, one of the TZ_ enumerated constants.
int32_t | m_nHourOffset
| The hour offset of the time's timezone.
int32_t | m_nMinuteOffset
| The minute offset of the time's timezone.

## Constructor & Destructor Documentation

RawTime | ( | int32_t | nHour,
|  | int32_t | nMinute,
|  | int32_t | nSecond,
|  | int32_t | nNano,
|  | bool | fUTC |
| ) |  |  | `[protected]`

Construct a raw POF time value.

Parameters:

  | nHour | the hour between 0 and 23 inclusive
  | nMinute | the minute value between 0 and 59 inclusive
  | nSecond | the second value between 0 and 59 inclusive (and theoretically 60 for a leap-second)
  | nNano | the nanosecond value between 0 and 999999999 inclusive
  | fUTC | true if the time value is UTC or false if the time value does not have an explicit time zone

RawTime | ( | int32_t | nHour,
|  | int32_t | nMinute,
|  | int32_t | nSecond,
|  | int32_t | nNano,
|  | int32_t | nHourOffset,
|  | int32_t | nMinuteOffset |
| ) |  |  | `[protected]`

Construct a raw POF time value with a timezone.

Parameters:

  | nHour | the hour between 0 and 23 inclusive
  | nMinute | the minute value between 0 and 59 inclusive
  | nSecond | the second value between 0 and 59 inclusive (and theoretically 60 for a leap-second)
  | nNano | the nanosecond value between 0 and 999999999 inclusive
  | nHourOffset | the timezone offset in hours from UTC, for example 0 for BST, -5 for EST and 1 for CET
  | nMinuteOffset | the timezone offset in minutes, for example 0 (in most cases) or 30

RawTime | ( | const struct tm & | timeinfo,
|  | bool | fUTC = `false` |
| ) |  |  | `[protected]`

Construct a raw POF time value from a POSIX datetime struct.

Note that the POSIX daylight savings flag is not preserved.

Parameters:

  | timeinfo | the POSIX time
  | fUTC | true if the time value is UTC or false if the time value does not have an explicit time zone

## Member Function Documentation

virtual int32_t getHour | ( |  | ) | const `[virtual]`

Determine the time's hour value.

Returns:
  the hour between 0 and 23 inclusive

virtual int32_t getMinute | ( |  | ) | const `[virtual]`

Determine the time's minute value.

Returns:
  the minute value between 0 and 59 inclusive

virtual int32_t getSecond | ( |  | ) | const `[virtual]`

Determine the time's second value.

Returns:
  the second value between 0 and 59 inclusive (and possibly 60 for a leap-second)

virtual int32_t getNano | ( |  | ) | const `[virtual]`

Determine the time's nanosecond value.

Returns:
  the nanosecond value between 0 and 999999999 inclusive

virtual bool hasTimezone | ( |  | ) | const `[virtual]`

Determine if the time value has an explicit timezone.

A time value without an explicit timezone is assumed to be in some conventional local timezone, according to ISO8601.

Returns:
  true iff the time has an explicit timezone

virtual bool isUTC | ( |  | ) | const `[virtual]`

Determine if the time value uses UTC.

Returns:
  true if the time value is a UTC value

virtual int32_t getHourOffset | ( |  | ) | const `[virtual]`

Determine the timezone's hour offset value.

Returns:
  the hour offset of the timezeone, or zero if there is no explicit timezone or the time is UTC

virtual int32_t getMinuteOffset | ( |  | ) | const `[virtual]`

Determine the timezone's minute offset value.

Returns:
  the minute offset of the timezeone, or zero if there is no explicit timezone or the time is UTC

virtual operator struct tm | ( |  | ) | const `[virtual]`

Convert the RawTime to a POSIX datetime struct.

Note that the nanosecond and timezone related information are not preserved.

The documentation for this class was generated from the following file:

- coherence/io/pof/RawTime.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.